package com.zskk.controller;

import com.jfinal.core.Controller;
import com.jfinal.weixin.sdk.api.SnsAccessToken;
import com.zskk.model.User;
import com.zskk.service.ServiceFactory;
import com.zskk.service.UserService;
import com.zskk.service.WeixinService;

public class WebBridgeController extends Controller {

	private static String WEB_BASR_URL = "http://wechat.client.pacsonline.cn/#";
	
	public void addBinding() {
		this.process(WEB_BASR_URL+"/bind");
	}
	
	public void examList() {
		this.process(WEB_BASR_URL+"/reportList");
	}

	public void aboutUs() {
		this.redirect("http://wechat.pacsonline.cn/pacs_online/html/aboutAs_zskk.html");
	}
	
	private void process(String toUrl) {
		try {
			Object sessionObj = this.getRequest().getSession().getAttribute("pwpSessionObjtest1");
			WeixinService wService = ServiceFactory.getService(WeixinService.class);
			if (sessionObj == null) {
				String code = this.getPara("code");
				if (code == null) {
					String url = wService.getCodeUrl("wxee1c68f8944d357b", getRequest().getRequestURL().toString());
					this.redirect(url);
					return;
				}
				SnsAccessToken snsAccessToken = wService.getWebAccessToken("wxee1c68f8944d357b", "1bc0128b6bbb3907c3bcf4a1704f2a1f", code);
				
				UserService uService = ServiceFactory.getService(UserService.class);
				User userWechats = User.dao.findFirst("select * from user where wx_openid=?",snsAccessToken.getOpenid());
				if (userWechats == null && snsAccessToken.getOpenid() != null) {
					userWechats = uService.createWxUser(snsAccessToken.getOpenid());
				}
				if (userWechats != null && userWechats.getWxIcon().isEmpty()) {                     
					wService.getWebWeixinUserInfo(snsAccessToken.getAccessToken(), snsAccessToken.getOpenid());
				}
				this.getRequest().getSession().setAttribute("pwpSessionObjtest1", userWechats);
				String uidStr = toUrl.contains("?") ? "&openid=" : "?openid=";
				this.redirect(toUrl + uidStr + snsAccessToken.getOpenid());
			} else {
				UserService uService = ServiceFactory.getService(UserService.class);
				User userWechats = (User) sessionObj;
				User users = User.dao.findById(userWechats.getId());
				String uidStr = toUrl.contains("?") ? "&openid=" : "?openid=";
				if (users == null) {
					userWechats = uService.createWxUser(userWechats.getWxOpenid());
				}
				User users2 = User.dao.findFirst("select * from user where wx_openid=?",userWechats.getWxOpenid());
				if (users2 != null && users2.getWxIcon().isEmpty()) {
//					uService.getUserInfo(userWechats.getWxOpenid());
//					wService.getWebWeixinUserInfo(snsAccessToken.getAccessToken(), snsAccessToken.getOpenid());

				}
//				
				this.getRequest().getSession().setAttribute("pwpSessionObjtest1", users2);
//
				this.redirect(toUrl + uidStr + userWechats.getWxOpenid());

				
			}
		} catch (Exception e) {
			// nothing
			this.redirect("http://www.pacsonline.cn");
			//this.renderText(e.toString());
		}
		
	}
	
}
