package com.zskk.service;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

import com.jfinal.weixin.sdk.api.ApiResult;
import com.jfinal.weixin.sdk.api.SnsAccessToken;
import com.jfinal.weixin.sdk.api.SnsAccessTokenApi;
import com.jfinal.weixin.sdk.api.SnsApi;
import com.zskk.model.User;

public class WeixinService {
	
	/**
	 * 用户同意授权，获取带code的url
	 * @return
	 * @throws UnsupportedEncodingException 
	 */
	public String getCodeUrl(String appId, String redirect_uri) throws UnsupportedEncodingException {
		String encode = URLEncoder.encode(redirect_uri, "UTF-8");
		String url = SnsAccessTokenApi.getAuthorizeURL(appId, encode, false);
		return url;
	}

	/**
	 * 通过回调地址参数code获取access_token
	 * @param appId
	 * @param secret
	 * @param code
	 * @return
	 */
	public SnsAccessToken getWebAccessToken(String appId, String secret, String code) {
		SnsAccessToken snsAccessToken = SnsAccessTokenApi.getSnsAccessToken(appId, secret, code);
		return snsAccessToken;
	}
	
	/**
	 * 拉取用户信息
	 * @param accessToken
	 * @param openId
	 * @return
	 */
	public ApiResult getWebWeixinUserInfo(String accessToken, String openId) {
		ApiResult apiResult = SnsApi.getUserInfo(accessToken, openId);
		User user = User.dao.findFirst("select * from user where wx_openid=?",openId);
		user.setWxIcon(apiResult.getStr("headimgurl"));
		user.setWxNickname(apiResult.getStr("nickname"));
		user.update();
		return apiResult;
	}
	
//	public static void main(String[] args) {
//		try {
//			String url = URLEncoder.encode("http://wechat.client.pacsonline.cn/#/bind", "UTF-8");
//			String ssString =  getCodeUrl("wxee1c68f8944d357b", url);
//			System.out.println(ssString);
//		} catch (UnsupportedEncodingException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//
//		
//	}
}
